/********************************** (C) COPYRIGHT  *******************************
* File Name          : CH395_interface_operation.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/10/12
* Description        : CH395ӿʵֺ
*******************************************************************************/ 
#include "CH395inc.h"                         /* ṩĶ */
#include "debug.h"                            /* ṩӳٺ */
#include "CH395_interface_operation.h"        /* ṩӿ */
#include "MCU_communication_interface.h"      /* ṩײӿ */

/*******************************************************************************
* Function Name  : ch395_cmd_reset
* Description    : λ
* Input          : None
* Return         : None
*******************************************************************************/
void ch395_cmd_reset(void)
{
    ch395_write_cmd(CMD00_RESET_ALL);
    ch395_scs_hign;
}

/*******************************************************************************
* Function Name  : ch395_cmd_hard_reset
* Description    : λ
* Input          : None
* Return         : None
*******************************************************************************/
void ch395_cmd_hard_reset(void)
{
    GPIO_ResetBits(GPIOA,GPIO_Pin_1);
	delay_ms(10);
	GPIO_SetBits(GPIOA,GPIO_Pin_1);
}

/*******************************************************************************
* Function Name  : ch395_cmd_sleep
* Description    : ˯ģʽ
* Input          : None
* Return         : None
*******************************************************************************/
void ch395_cmd_sleep(void)
{
    ch395_write_cmd(CMD00_ENTER_SLEEP);
    ch395_scs_hign;
}

uint8_t ch395_cmd_get_ver(void)
{
    uint8_t i;
    ch395_write_cmd(CMD01_GET_IC_VER);
    i = ch395_read_data();
    ch395_scs_hign;
    return i;
}

uint8_t ch395_cmd_check_exist(uint8_t testdata)
{
    uint8_t i;

    ch395_write_cmd(CMD11_CHECK_EXIST);
    ch395_write_data(testdata);
	
//	delay_ms(100);
    i = ch395_read_data();
	printf("ch395_cmd_check_exist=%02x\r\n",i);
	delay_us(1);
    ch395_scs_hign;
    return i;
}


/*******************************************************************************
* Function Name  : ch395_cmd_set_phy
* Description    : phyҪCH395 phyΪ100/10m ȫ˫˫CH395ĬΪԶЭ̡
* Input          : None
* Return         : None
*******************************************************************************/ 
void ch395_cmd_set_phy(uint8_t phystat)
{
    ch395_write_cmd(CMD10_SET_PHY);
    ch395_write_data(phystat);
    ch395_scs_hign;
}

/*******************************************************************************
* Function Name  : ch395_cmd_get_phy_status
* Description    : ȡphy״̬
* Input          : None
* Return         : ǰch395phy״̬οphy/״̬
*******************************************************************************/ 
uint8_t ch395_cmd_get_phy_status(void)
{
    uint8_t i;

    ch395_write_cmd(CMD01_GET_PHY_STATUS);
    i = ch395_read_data();
    ch395_scs_hign;
	printf("phy_status:%04x\n",i);
    return i;
}

/*******************************************************************************
* Function Name  : ch395_cmd_get_glob_int_status
* Description    : ȡȫж״̬յCH395Զȡжϣ0x43°汾ʹ
* Input          : None
* Return         : صǰȫж״̬
*******************************************************************************/ 
uint8_t ch395_cmd_get_glob_int_status(void)
{
    uint8_t init_status;

    ch395_write_cmd(CMD01_GET_GLOB_INT_STATUS);
    init_status = ch395_read_data();
    ch395_scs_hign;
    return  init_status;
}


/*******************************************************************************
* Function Name  : ch395_cmd_init
* Description    : ʼCH395оƬ
* Input          : None
* Return         : ִн
*******************************************************************************/ 
uint8_t ch395_cmd_init(void)
{
    uint8_t i = 0;
    uint8_t s = 0;

    ch395_write_cmd(CMD0W_INIT_CH395);
    ch395_scs_hign;
	
    while (1)
    {
        delay_ms(10);                          /* ʱѯ2MS */
        s = ch395_get_cmd_status();            /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;         /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW; /* ʱ˳,Ҫ500MSִ */
        }
    }

    return s;
}


/*******************************************************************************
* Function Name  : ch395_cmd_set_uart_baud_rate
* Description    : CH395ڲʣڴģʽЧ
* Input          : baudrate
* Return         : None
*******************************************************************************/ 
#ifdef USE_USART2_CTRL_CH395
void ch395_cmd_set_uart_baud_rate(uint32_t baudrate)
{
    ch395_write_cmd(CMD31_SET_BAUDRATE);
    ch395_write_data((uint8_t)baudrate);
    ch395_write_data((uint8_t)((uint16_t)baudrate >> 8));
    ch395_write_data((uint8_t)(baudrate >> 16));
	delay_ms(1);
	set_usart2_bandrate(UART_WORK_BAUDRATE);
	
    uint8_t i = ch395_read_data();
//	printf("baudrate_i:%02x\n",i);
    ch395_scs_hign;
}
#endif

/*******************************************************************************
* Function Name  : ch395_get_cmd_status
* Description    : ȡִ״̬ĳЩҪȴִн
* Input          : None
* Return         : һִ״̬
*******************************************************************************/ 
uint8_t ch395_get_cmd_status(void)
{
    uint8_t i;

    ch395_write_cmd(CMD01_GET_CMD_STATUS);
    i = ch395_read_data();
//	printf("ch395_get_cmd_status:%06x\n",i);
    ch395_scs_hign;
    return i;
}


/*******************************************************************************
* Function Name  : ch395_get_cmd_status
* Description    : CH395ipַ
* Input          : ipaddripַ
* Return         : None
*******************************************************************************/
void ch395_cmd_set_ipaddr(uint8_t *ipaddr)
{
    uint8_t i;

    ch395_write_cmd(CMD40_SET_IP_ADDR);

    for (i = 0; i < 4; i++)
    {
        ch395_write_data(*ipaddr++);
    }

    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_cmd_set_gw_ipaddr
* Description    : CH395ipַ
* Input          : gwipaddr
* Return         : None
*******************************************************************************/
void ch395_cmd_set_gw_ipaddr(uint8_t *gwipaddr)
{
    uint8_t i;

    ch395_write_cmd(CMD40_SET_GWIP_ADDR);

    for (i = 0; i < 4; i++)
    {
        ch395_write_data(*gwipaddr++);
    }

    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_cmd_set_maskaddr
* Description    : CH395룬ĬΪ255.255.255.0
* Input          : maskaddr ַָ
* Return         : None
*******************************************************************************/
void ch395_cmd_set_maskaddr(uint8_t *maskaddr)
{
    uint8_t i;

    ch395_write_cmd(CMD40_SET_MASK_ADDR);

    for (i = 0; i < 4; i++)
    {
        ch395_write_data(*maskaddr++);
    }

    ch395_scs_hign;
}

/*******************************************************************************
* Function Name  : ch395_cmd_set_macaddr
* Description    : CH395macַ
* Input          : mcaddr macַָ
* Return         : None
*******************************************************************************/
void ch395_cmd_set_macaddr(uint8_t *amcaddr)
{
    uint8_t i;

    ch395_write_cmd(CMD60_SET_MAC_ADDR);

    for (i = 0; i < 6; i++)
    {
        ch395_write_data(*amcaddr++);
    }

    ch395_scs_hign;
    delay_ms(100);
}


/*******************************************************************************
* Function Name  : ch395_cmd_get_macaddr
* Description    : ȡCH395macַ
* Input          : amcaddr macַָ
* Return         : None
*******************************************************************************/
void ch395_cmd_get_macaddr(uint8_t *amcaddr)
{
    uint8_t i;

    ch395_write_cmd(CMD06_GET_MAC_ADDR);

    for (i = 0; i < 6; i++)
    {
        *amcaddr++ = ch395_read_data();
    }

    ch395_scs_hign;
}



/*******************************************************************************
* Function Name  : ch395_cmd_set_macfilt
* Description    : macˡ
* Input          : filtype
				   table0 hash0
				   table1 hash1
* Return         : None
*******************************************************************************/
void ch395_cmd_set_macfilt(uint8_t filtype, uint32_t table0, uint32_t table1)
{
    ch395_write_cmd(CMD90_SET_MAC_FILT);
    ch395_write_data(filtype);

    ch395_write_data((uint8_t)table0);
    ch395_write_data((uint8_t)(table0 >> 8));
    ch395_write_data((uint8_t)(table0 >> 16));
    ch395_write_data((uint8_t)(table0 >> 24));

    ch395_write_data((uint8_t)table1);
    ch395_write_data((uint8_t)(table1 >> 8));
    ch395_write_data((uint8_t)(table1 >> 16));
    ch395_write_data((uint8_t)(table1 >> 24));
    ch395_scs_hign;
}

/*******************************************************************************
* Function Name  : ch395_cmd_get_unreachippt
* Description    : ȡĲɴ
* Input          : list
*	arg          : 1ֽΪɴ룬ο ɴ(ch395inc.h)
				   2ֽΪipЭ
			       3-4ֽΪ˿ں
				   4-8ֽΪipַ
* Return         : None
*******************************************************************************/
void ch395_cmd_get_unreachippt(uint8_t *list)
{
    uint8_t i;

    ch395_write_cmd(CMD08_GET_UNREACH_IPPORT);

    for (i = 0; i < 8; i++)
    {
        *list++ = ch395_read_data();
    }

    ch395_scs_hign;
}

/**
 * @brief       ȡԶ˵ipͶ˿ڵַһtcp serverģʽʹ
 * @param       sockindex socket
 * @param       list ipͶ˿
 * @retval      
 */

/*******************************************************************************
* Function Name  : ch395_cmd_get_remoteipp
* Description    : ȡԶ˵ipͶ˿ڵַһtcp serverģʽʹ
* Input          : sockindex socket
                   list ipͶ˿
* Return         : None
*******************************************************************************/
void ch395_cmd_get_remoteipp(uint8_t sockindex, uint8_t *list)
{
    uint8_t i;

    ch395_write_cmd(CMD06_GET_REMOT_IPP_SN);
    ch395_write_data(sockindex);

    for (i = 0; i < 6; i++)
    {
        *list++ = ch395_read_data();
    }

    ch395_scs_hign;
}



/*******************************************************************************
* Function Name  : ch395_set_socket_desip
* Description    : socket nĿipַ
* Input          : sockindex socket
                   ipaddr ָipַ
* Return         : None
*******************************************************************************/
void ch395_set_socket_desip(uint8_t sockindex, uint8_t *ipaddr)
{
    ch395_write_cmd(CMD50_SET_IP_ADDR_SN);
    ch395_write_data(sockindex);
    ch395_write_data(*ipaddr++);
    ch395_write_data(*ipaddr++);
    ch395_write_data(*ipaddr++);
    ch395_write_data(*ipaddr++);
    ch395_scs_hign;
}



/*******************************************************************************
* Function Name  : ch395_set_socket_prot_type
* Description    : socket Э
* Input          : sockindex socket
                   prottype
				   ο socketЭͶ(ch395inc.h)
* Return         : None
*******************************************************************************/
void ch395_set_socket_prot_type(uint8_t sockindex, uint8_t prottype)
{
    ch395_write_cmd(CMD20_SET_PROTO_TYPE_SN);
    ch395_write_data(sockindex);
    ch395_write_data(prottype);
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_set_socket_desport
* Description    : socket nЭ
* Input          : sockindex socket
                   desprot 2ֽĿĶ˿
* Return         : None
*******************************************************************************/
void ch395_set_socket_desport(uint8_t sockindex, uint16_t desprot)
{
    ch395_write_cmd(CMD30_SET_DES_PORT_SN);
    ch395_write_data(sockindex);
    ch395_write_data((uint8_t)desprot);
    ch395_write_data((uint8_t)(desprot >> 8));
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_set_socket_sourport
* Description    : socket nЭ
* Input          : sockindex socket
                   desprot 2ֽԴ˿
* Return         : None
*******************************************************************************/
void ch395_set_socket_sourport(uint8_t sockindex, uint16_t surprot)
{
    ch395_write_cmd(CMD30_SET_SOUR_PORT_SN);
    ch395_write_data(sockindex);
    ch395_write_data((uint8_t)surprot);
    ch395_write_data((uint8_t)(surprot >> 8));
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_set_socket_ipraw_proto
* Description    : ipģʽ£socket ipЭֶ
* Input          : sockindex socket
                   prototype iprawģʽ1ֽЭֶ
* Return         : None
*******************************************************************************/
void ch395_set_socket_ipraw_proto(uint8_t sockindex, uint8_t prototype)
{
    ch395_write_cmd(CMD20_SET_IPRAW_PRO_SN);
    ch395_write_data(sockindex);
    ch395_write_data(prototype);
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_enable_ping
* Description    : /ر ping
* Input          : senable :0 / 1
				   1:  ping
				   0:  رping
* Return         : None
*******************************************************************************/
void ch395_enable_ping(uint8_t enable)
{
    ch395_write_cmd(CMD01_PING_ENABLE);
    ch395_write_data(enable);
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_send_data
* Description    : ͻд
* Input          : sockindex socket
                   databuf  ݻ
				   len   
* Return         : None
*******************************************************************************/
void ch395_send_data(uint8_t sockindex, uint8_t *databuf, uint16_t len)
{
    uint16_t i;

    ch395_write_cmd(CMD30_WRITE_SEND_BUF_SN);
    ch395_write_data((uint8_t)sockindex);
    ch395_write_data((uint8_t)len);
    ch395_write_data((uint8_t)(len >> 8));

    for (i = 0; i < len; i++)
    {
        ch395_write_data(*databuf++);
    }

    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_get_recv_length
* Description    : ȡջ
* Input          : sockindex socket
* Return         : ؽջЧ
*******************************************************************************/
uint16_t ch395_get_recv_length(uint8_t sockindex)
{
    uint16_t i;

    ch395_write_cmd(CMD12_GET_RECV_LEN_SN);
    ch395_write_data((uint8_t)sockindex);
    i = ch395_read_data();
    i = (uint16_t)(ch395_read_data() << 8) + i;
    ch395_scs_hign;
    return i;
}



/*******************************************************************************
* Function Name  : ch395_clear_recv_buf
* Description    : ջ
* Input          : sockindex socket
* Return         : 
*******************************************************************************/
void ch395_clear_recv_buf(uint8_t sockindex)
{
    ch395_write_cmd(CMD10_CLEAR_RECV_BUF_SN);
    ch395_write_data((uint8_t)sockindex);
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_get_recv_data
* Description    : ȡջ
* Input          : sockindex socket
				   len  
                   pbuf  
* Return         : 
*******************************************************************************/
void ch395_get_recv_data(uint8_t sockindex, uint16_t len, uint8_t *pbuf)
{
    uint16_t i;

    if (!len)return;

    ch395_write_cmd(CMD30_READ_RECV_BUF_SN);
    ch395_write_data(sockindex);
    ch395_write_data((uint8_t)len);
    ch395_write_data((uint8_t)(len >> 8));
    delay_us(1);

    for (i = 0; i < len; i++)
    {
        *pbuf = ch395_read_data();
        pbuf++;
    }

    ch395_scs_hign;
}



/*******************************************************************************
* Function Name  : ch395_cmd_set_retry_count
* Description    : Դ
* Input          : count ֵΪ20
* Return         : 
*******************************************************************************/
void ch395_cmd_set_retry_count(uint8_t count)
{
    ch395_write_cmd(CMD10_SET_RETRAN_COUNT);
    ch395_write_data(count);
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_cmd_set_retry_period
* Description    : 
* Input          : period ڵλΪ룬1000ms
* Return         : 
*******************************************************************************/
void ch395_cmd_set_retry_period(uint16_t period)
{
    ch395_write_cmd(CMD10_SET_RETRAN_COUNT);
    ch395_write_data((uint8_t)period);
    ch395_write_data((uint8_t)(period >> 8));
    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_cmd_get_socket_status
* Description    : ȡsocket
* Input          : sockindex socket
* Return         : socket n״̬Ϣ1ֽΪsocket 򿪻߹ر,2ֽΪtcp״̬
*******************************************************************************/
void ch395_cmd_get_socket_status(uint8_t sockindex, uint8_t *status)
{
    ch395_write_cmd(CMD12_GET_SOCKET_STATUS_SN);
    ch395_write_data(sockindex);
    *status++ = ch395_read_data();
    *status++ = ch395_read_data();
    ch395_scs_hign;
}



/*******************************************************************************
* Function Name  : ch395_open_socket
* Description    : socketҪȴִгɹ
* Input          : sockindex socket
* Return         : ִн
*******************************************************************************/
uint8_t  ch395_open_socket(uint8_t sockindex)
{
    uint8_t i = 0;
    uint8_t s = 0;
    ch395_write_cmd(CMD1W_OPEN_SOCKET_SN);
    ch395_write_data(sockindex);
    ch395_scs_hign;

    while (1)
    {
        delay_ms(5);                          /* ʱѯ2MS */
        s = ch395_get_cmd_status();           /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;        /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW; /* ʱ˳ */
        }
    }

    return s;
}



/*******************************************************************************
* Function Name  : ch395_close_socket
* Description    : رsocket
* Input          : sockindex socket
* Return         : ִн
*******************************************************************************/
uint8_t  ch395_close_socket(uint8_t sockindex)
{
    uint8_t i = 0;
    uint8_t s = 0;
    ch395_write_cmd(CMD1W_CLOSE_SOCKET_SN);
    ch395_write_data(sockindex);
    ch395_scs_hign;

    while (1)
    {
        delay_ms(5);                            /* ʱѯ2MS */
        s = ch395_get_cmd_status();             /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;          /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW;  /* ʱ˳ */
        }
    }

    return s;
}

/*******************************************************************************
* Function Name  : ch395_tcp_connect
* Description    : tcpӣtcpģʽЧҪȴִгɹ
* Input          : sockindex socket
* Return         : ִн
*******************************************************************************/
uint8_t ch395_tcp_connect(uint8_t sockindex)
{
    uint8_t i = 0;
    uint8_t s = 0;
    ch395_write_cmd(CMD1W_TCP_CONNECT_SN);
    ch395_write_data(sockindex);
    ch395_scs_hign;

    while (1)
    {
        delay_ms(5);                            /* ʱѯ2MS */
        s = ch395_get_cmd_status();             /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;          /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW;  /* ʱ˳ */
        }
    }

    return s;
}


/*******************************************************************************
* Function Name  : ch395_tcp_listen
* Description    : tcptcpģʽЧҪȴִгɹ
* Input          : sockindex socket
* Return         : ִн
*******************************************************************************/
uint8_t ch395_tcp_listen(uint8_t sockindex)
{
    uint8_t i = 0;
    uint8_t s = 0;
    ch395_write_cmd(CMD1W_TCP_LISTEN_SN);
    ch395_write_data(sockindex);
    ch395_scs_hign;

    while (1)
    {
        delay_ms(5);                           /* ʱѯ2MS */
        s = ch395_get_cmd_status();            /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;         /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW; /* ʱ˳ */
        }
    }

    return s;
}


/*******************************************************************************
* Function Name  : ch395_tcp_disconnect
* Description    : tcpϿtcpģʽЧҪȴִгɹ
* Input          : sockindex socket
* Return         : ִн
*******************************************************************************/
uint8_t ch395_tcp_disconnect(uint8_t sockindex)
{
    uint8_t i = 0;
    uint8_t s = 0;
    ch395_write_cmd(CMD1W_TCP_DISNCONNECT_SN);
    ch395_write_data(sockindex);
    ch395_scs_hign;

    while (1)
    {
        delay_ms(5);                           /* ʱѯ2MS */
        s = ch395_get_cmd_status();               /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;         /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW; /* ʱ˳ */
        }
    }

    return s;
}

/*******************************************************************************
* Function Name  : ch395_get_socket_int
* Description    : ȡsocket nж״̬
* Input          : sockindex socket
* Return         : ж״̬
*******************************************************************************/
uint8_t ch395_get_socket_int(uint8_t sockindex)
{
    uint8_t intstatus;
    ch395_write_cmd(CMD11_GET_INT_STATUS_SN);
    ch395_write_data(sockindex);
    delay_us(2);
    intstatus = ch395_read_data();
    ch395_scs_hign;
    return intstatus;
}

/*******************************************************************************
* Function Name  : ch395_crcret_6bit
* Description    : Զಥַcrc㣬ȡ6λ
* Input          : mac_addr   macַ
* Return         : crc32ĸ6λ
*******************************************************************************/
uint8_t ch395_crcret_6bit(uint8_t *mac_addr)
{
    signed long perbyte;
    signed long perbit;
    const uint32_t poly = 0x04c11db7;
    uint32_t crc_value = 0xffffffff;
    uint8_t c;

    for ( perbyte = 0; perbyte < 6; perbyte ++ )
    {
        c = *(mac_addr++);

        for ( perbit = 0; perbit < 8; perbit++ )
        {
            crc_value = (crc_value << 1) ^ ((((crc_value >> 31)^c) & 0x01) ? poly : 0);
            c >>= 1;
        }
    }

    crc_value = crc_value >> 26;
    return ((uint8_t)crc_value);
}


/*******************************************************************************
* Function Name  : ch395_dhcp_enable
* Description    : /ֹͣdhcp
* Input          : flag:0 / 1, 庬:
*   @arg        1: dhcp
*   @arg        0ֹͣdhcp
* Return         : crc32ĸ6λ
*******************************************************************************/
uint8_t  ch395_dhcp_enable(uint8_t flag)
{
    uint8_t i = 0;
    uint8_t s;
    ch395_write_cmd(CMD10_DHCP_ENABLE);
    ch395_write_data(flag);
    ch395_scs_hign;

    while (1)
    {
        delay_ms(20);
        s = ch395_get_cmd_status();            /* ܹƵѯ */

        if (s != CH395_ERR_BUSY)
        {
            break;         /* CH395оƬæ״̬ */
        }

        if (i++ > 200)
        {
            return CH395_ERR_UNKNOW; /* ʱ˳ */
        }
    }

    return s;
}

/*******************************************************************************
* Function Name  : ch395_get_dhcp_status
* Description    : ȡdhcp״̬
* Input          : None
* Return         : dhcp״̬0Ϊɹֵʾ
*******************************************************************************/
uint8_t ch395_get_dhcp_status(void)
{
    uint8_t status;
    ch395_write_cmd(CMD01_GET_DHCP_STATUS);
    status = ch395_read_data();
    ch395_scs_hign;
    return status;
}

/*******************************************************************************
* Function Name  : ch395_get_ipinf
* Description    : ȡipصַ
* Input          : sockindex socket
* Return         : 12ֽڵip,صַ
*******************************************************************************/
void ch395_get_ipinf(uint8_t *addr)
{
    uint8_t i;
    ch395_write_cmd(CMD014_GET_IP_INF);

    for (i = 0; i < 20; i++)
    {
        *addr++ = ch395_read_data();
    }

    ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_write_gpio_addr
* Description    : дgpioĴ
* Input          : regadd   Ĵַ
									 regval   Ĵֵ
* Return         : None
*******************************************************************************/
void ch395_write_gpio_addr(uint8_t regadd, uint8_t regval)
{
    ch395_write_cmd(CMD20_WRITE_GPIO_REG);
    ch395_write_data(regadd);
    ch395_write_data(regval);
}


/*******************************************************************************
* Function Name  : ch395_read_gpio_addr
* Description    : gpioĴ
* Input          : regadd   Ĵַ
* Return         : Ĵֵ
*******************************************************************************/
uint8_t ch395_read_gpio_addr(uint8_t regadd)
{
    uint8_t i;
    ch395_write_cmd(CMD10_READ_GPIO_REG);
    ch395_write_data(regadd);
    delay_ms(1);
    i = ch395_read_data();
    return i;
}

/*******************************************************************************
* Function Name  : ch395_eeprom_erase
* Description    : eeprom
* Input          : None
* Return         : ִ״̬
*******************************************************************************/
uint8_t ch395_eeprom_erase(void)
{
    uint8_t i;
    ch395_write_cmd(CMD00_EEPROM_ERASE);

    while (1)
    {
        delay_ms(20);
        i = ch395_get_cmd_status();

        if (i == CH395_ERR_BUSY)
        {
            continue;
        }

        break;
    }

    return i;
}

/*******************************************************************************
* Function Name  : ch395_eeprom_write
* Description    : дeeprom
* Input          : eepaddr  eepromַ
									 buf      ַ
									 len      
* Return         : ִ״̬
*******************************************************************************/
uint8_t ch395_eeprom_write(uint16_t eepaddr, uint8_t *buf, uint8_t len)
{
    uint8_t i;
    ch395_write_cmd(CMD30_EEPROM_WRITE);
    ch395_write_data((uint8_t)(eepaddr));
    ch395_write_data((uint8_t)(eepaddr >> 8));
    ch395_write_data(len);

    while (len--)ch395_write_data(*buf++);

    while (1)
    {
        delay_ms(20);
        i = ch395_get_cmd_status();

        if (i == CH395_ERR_BUSY)
        {
            continue;
        }

        break;
    }

    return i;
}

/*******************************************************************************
* Function Name  : ch395_eeprom_write
* Description    : eeprom
* Input          : eepaddr  eepromַ
				   buf      ַ
				   len      
* Return         : None
*******************************************************************************/
void ch395_eeprom_read(uint16_t eepaddr, uint8_t *buf, uint8_t len)
{
    ch395_write_cmd(CMD30_EEPROM_READ);
    ch395_write_data((uint8_t)(eepaddr));
    ch395_write_data((uint8_t)(eepaddr >> 8));
    ch395_write_data(len);
    delay_ms(1);

    while (len--)
    {
        *buf++ = ch395_read_data();
    }
}


/*******************************************************************************
* Function Name  : ch395_set_tcpmss
* Description    : tcp mssֵ
* Input          : tcpmss
* Return         : None
*******************************************************************************/
void ch395_set_tcpmss(uint16_t tcpmss)
{
    ch395_write_cmd(CMD20_SET_TCP_MSS);
    ch395_write_data((uint8_t)(tcpmss));
    ch395_write_data((uint8_t)(tcpmss >> 8));
	ch395_scs_hign;
}


/*******************************************************************************
* Function Name  : ch395_set_socket_recv_buf
* Description    : socketջ
* Input          : sockindex  socket,ַ,blknum
				   startblk   ʼַ
				   λ λΪ512ֽ
* Return         : None
*******************************************************************************/
void ch395_set_socket_recv_buf(uint8_t sockindex, uint8_t startblk, uint8_t blknum)
{
    ch395_write_cmd(CMD30_SET_RECV_BUF);
    ch395_write_data(sockindex);
    ch395_write_data(startblk);
    ch395_write_data(blknum);
	ch395_scs_hign;
//	delay_us(2);
}


/*******************************************************************************
* Function Name  : ch395_set_socket_send_buf
* Description    : socketͻ
* Input          : sockindex  socket,ַ,blknum
				   startblk   ʼַ
				   λ λΪ512ֽ
* Return         : None
*******************************************************************************/
void ch395_set_socket_send_buf(uint8_t sockindex, uint8_t startblk, uint8_t blknum)
{
    ch395_write_cmd(CMD30_SET_SEND_BUF);
    ch395_write_data(sockindex);
    ch395_write_data(startblk);
    ch395_write_data(blknum);
	ch395_scs_hign;
//	delay_us(2);
}

/*******************************************************************************
* Function Name  : ch395_udp_send_data
* Description    : udpָipͶ˿ڷ
* Input          : buf     : ݻ
				   len     : ݳ
				   ip      : Ŀip
				   port    : Ŀ˿
				   sockeid : socketֵ
* Return         : None
*******************************************************************************/
void ch395_udp_send_data(uint8_t *buf, uint32_t len, uint8_t *ip, uint16_t port, uint8_t sockindex)
{
    ch395_set_socket_desip(sockindex, ip);   /* socket 0ĿIPַ */
    ch395_set_socket_desport(sockindex, port);
    ch395_send_data(sockindex, buf, len);
}

/*******************************************************************************
* Function Name  : ch395_set_start_para
* Description    : CH395
* Input          : madata
* Return         : None
*******************************************************************************/
void ch395_set_start_para(uint32_t mdata)
{
    ch395_write_cmd(CMD40_SET_FUN_PARA);
    ch395_write_data((uint8_t)mdata);
    ch395_write_data((uint8_t)((uint16_t)mdata >> 8));
    ch395_write_data((uint8_t)(mdata >> 16));
    ch395_write_data((uint8_t)(mdata >> 24));
	  ch395_scs_hign;
}
/*******************************************************************************
* Function Name  : ch395_cmd_get_glob_int_status_all
* Description    : ȡȫж״̬յCH395Զȡж,0x44ϰ汾ʹ
* Input          : None
* Return         : صǰȫж״̬
*******************************************************************************/
uint16_t ch395_cmd_get_glob_int_status_all(void)
{
    uint16_t init_status;
    ch395_write_cmd(CMD02_GET_GLOB_INT_STATUS_ALL);
    delay_us(2);
    init_status = ch395_read_data();
    init_status = (uint16_t)(ch395_read_data() << 8) + init_status;
    ch395_scs_hign;
    return  init_status;
}
/*******************************************************************************
* Function Name  : ch395_set_keeplive
* Description    : keepalive
* Input          : sockindex Socket
				   cmd 0ر 1
* Return         : None
*******************************************************************************/
void ch395_set_keeplive(uint8_t sockindex, uint8_t cmd)
{
    ch395_write_cmd(CMD20_SET_KEEP_LIVE_SN);
    ch395_write_data(sockindex);
    ch395_write_data(cmd);
}
/*******************************************************************************
* Function Name  : ch395_keeplive_cnt
* Description    : keepaliveԴ
* Input          : cnt Դ
* Return         : None
*******************************************************************************/
void ch395_keeplive_cnt(uint8_t cnt)
{
    ch395_write_cmd(CMD10_SET_KEEP_LIVE_CNT);
    ch395_write_data(cnt);
}
/*******************************************************************************
* Function Name  : ch395_keeplive_idle
* Description    : KEEPLIVE
* Input          : idle ʱ䣨λms
* Return         : None
*******************************************************************************/
void ch395_keeplive_idle(uint32_t idle)
{
    ch395_write_cmd(CMD40_SET_KEEP_LIVE_IDLE);
    ch395_write_data((uint8_t)idle);
    ch395_write_data((uint8_t)((uint16_t)idle >> 8));
    ch395_write_data((uint8_t)(idle >> 16));
    ch395_write_data((uint8_t)(idle >> 24));
}
/*******************************************************************************
* Function Name  : ch395_keeplive_intvl
* Description    : KeepLiveʱ 
* Input          : intvl ʱ䣨λms
* Return         : None
*******************************************************************************/
void ch395_keeplive_intvl(uint32_t intvl)
{
    ch395_write_cmd(CMD40_SET_KEEP_LIVE_INTVL);
    ch395_write_data((uint8_t)intvl);
    ch395_write_data((uint8_t)((uint16_t)intvl >> 8));
    ch395_write_data((uint8_t)(intvl >> 16));
    ch395_write_data((uint8_t)(intvl >> 24));
}
/*******************************************************************************
* Function Name  : ch395_setttl_num
* Description    : TTL
* Input          : sockindex Socket
				   TTLnum:TTL
* Return         : None
*******************************************************************************/
void ch395_setttl_num(uint8_t sockindex, uint8_t ttlnum)
{
    ch395_write_cmd(CMD20_SET_TTL);
    ch395_write_data(sockindex);
    ch395_write_data(ttlnum);
}
