/********************************** (C) COPYRIGHT  *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/10/12
* Description        : Main program body.
*******************************************************************************/ 
#include "debug.h"
#include "string.h"
#include "ch395.h"
#include "ch395inc.h"
#include "CH395_network_operation.h"
#include "CH395_interface_operation.h"
#include "MCU_communication_interface.h"
 
/* IP */
const uint8_t local_ip[4] = {192,168,1,130};                       /* CH395IPַ */
const uint8_t gateway_ip[4] = {192,168,1,1};                       /* CH395 */
const uint8_t mask_ip[4] = {255,255,255,0};                        /* CH395 */
/* socket ض*/
const uint8_t  BroadcastIP[4] = {255,255,255,255};                 /* UDP㲥ַ */
const uint16_t Socket0DesPort = 6003;                              /* Socket 0ĿĶ˿ */
const uint16_t Socket0SourPort = 6000;                             /* Socket 0Դ˿ */

/* ಥIPϢ */
uint8_t  MulticastIP[4] = {224,1,1,4};                             /* ಥIPַ */
uint8_t  MultiMac[6]    = {1,0,0x5e,1,1,4};                        /* ӦಥMacַ */

/* ñ */
uint8_t  socket_buff[8][512];                                      /* ݻ */
struct _SOCK_INF sockinf[8];                                       /* SocketϢ */
struct _CH395_SYS  CH395Inf;                                       /* CH395Ϣ */

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{	
	uint8_t MacCrc32,rc;
	uint32_t Hash0 = 0,Hash1 = 0;
	
	Delay_Init();/* ӳٺʼ */
	USART_Printf_Init(921600);
	
	printf("\nWCH CH395 TCP server demo.Complair @ %s.%s\nPlatform:CH32F1 family.\n",__TIME__,__DATE__);
	CH395_if_init();                             /* CH32F103ƽӿڳʼ */
	ch395_inf_init();                            /* CH395Ϣʼ */
	ch395_cmd_hard_reset();
	delay_ms(500);
	
	rc=CH395_init();                             /* CH395óʼ */
    stop_if_error(rc);                           /*  */
	ch395_cmd_get_phy_status();
	
	MacCrc32 =  ch395_crcret_6bit(MultiMac);
    printf("MacCrc32 : %2x\n",(uint16_t)MacCrc32);
    if(MacCrc32 > 31)
    {
        MacCrc32 -=32;
		printf("MacCrc32_2 : %2x\n",(uint16_t)MacCrc32);
        Hash1 = Hash1|((uint32_t)1<<MacCrc32);
    }
    else
    {
        Hash0 |= ((uint32_t)1<<MacCrc32);
    }
	printf("Hash0:%lx\r\n",(uint32_t)Hash0);
    printf("Hash1:%lx\r\n",(uint32_t)Hash1);
	
	ch395_cmd_set_macfilt(0x1d, Hash0, Hash1);
	
    while(1)
    {                                                                 /* ȴ̫ӳɹ*/
       if(ch395_cmd_get_phy_status() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           delay_ms(200);                                            /* δȴ200MSٴβѯ */
       }
       else 
       {
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
           break;
       }
    }

	ch395_socket_init();                         /* socketϢʼ */
	socket_open();                               /* socket */
	while(1);
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindexsocket
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(uint8_t sockindex)
{
   uint8_t  sock_int_socket;
   uint16_t len;
   uint16_t tmp,port;

   sock_int_socket = ch395_get_socket_int(sockindex);                /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {
	   printf("send buff free!\n");
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
	   printf("send ok!\n");
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
		len = ch395_get_recv_length(sockindex);                        /* ȡǰݳ */
		if(len == 0)return;
		if(len > 512)len = 512;                /* MyBufferΪ512*/
		ch395_get_recv_data(sockindex,len,socket_buff[sockindex]);     /* ȡ */
		tmp = ((uint16_t)socket_buff[0][1] << 8) + socket_buff[0][0];
		port = ((uint16_t)socket_buff[0][3] << 8) + socket_buff[0][2];
		printf("Data Len = %d\n",tmp);
		printf("Port = %d\n",port);
		printf("IP = %2d.%2d.%2d.%2d.\n",(uint16_t)socket_buff[0][4],(uint16_t)socket_buff[0][5],(uint16_t)socket_buff[0][6],(uint16_t)socket_buff[0][7]); 
		ch395_udp_send_data(&socket_buff[0][0],(len-0),&socket_buff[0][4],port,sockindex);
		return;
   }
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
	uint16_t  init_status,tem_flag;
	uint8_t  i,buf[10]; 

	init_status = ch395_cmd_get_glob_int_status_all();
	if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
	{
		ch395_cmd_get_unreachippt(buf);                                
	}
	if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
	{
	}
	if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
	{
		printf("Init status : GINT_STAT_PHY_CHANGE\n");
	}
	tem_flag=GINT_STAT_SOCK0;
	for(i=0;i<8;i++)
	{
		if(init_status & tem_flag)
			CH395SocketInterrupt(i);   
		tem_flag=(1<<(4+1+i));
	}
}

/**********************************************************************************
* Function Name  : EXTI0_IRQHandler
* Description    : CH32EXTIжϷ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void EXTI0_IRQHandler(void)
{
  if(EXTI_GetITStatus(EXTI_Line0)!=RESET)
  {
    while(ch395_exti_stat==0)
		CH395GlobalInterrupt();
    EXTI_ClearITPendingBit(EXTI_Line0);     /* Clear Flag */  
  }
}


